/*****************************************************************************
   file         : $Id: each.h,v 1.1 2006/09/07 14:06:25 nils Exp $
   description  : forward declarations for xml system
   ------------------------------------------------------------------------

   copyright    : (C) 2006 by Nils Springob, Aachen, GERMANY
   email        : nils.springob@nicai-systems.de
   project      : nicai-systems library

 *****************************************************************************/

#ifndef _NICAI_EACH_H_
#define _NICAI_EACH_H_

namespace nicai {

template <class I>
class each
{
  private:
    I pos;
    I end;
  public:
    typedef typename I::value_type value_type;
    typedef typename I::reference reference;
    typedef typename I::pointer pointer;

    each(I _begin, I _end) : pos(_begin), end(_end) {}
    operator bool() const {return pos!=end;}
    value_type & operator* () {return *pos;}
    value_type * operator-> () {return &*pos;}
    const reference operator* () const {return **pos;}
    const pointer operator-> () const {return *pos;}
    each & operator++ () {++pos; return *this;}
    each operator++ (int) {each ret(*this); ++pos; return ret;}
    each & operator-- () {--pos; return *this;}
    each operator-- (int) {each ret(*this); --pos; return ret;}
};

} // namespace

#endif
