#include <iostream>
#include "nicai/xml/stream.h"
#include "nicai/xml/element.h"

// This is an heavy weight example....

std::string xmltext =
    "<?xml version=\"1.0\" ?>"
    "<TestElement attr='123'>"
    "  <Test2 attr='456'>"
    "A small <b>test text</b>..."
    "  </Test2>"
    "  <!-- a comment <a></a> -->"
    "  <Test3 a='1' b='2' d='3' c='4' e='6' f='5'/>"
    "<![CDATA[abc]]>"
    "<![CDATA["
    "some dirty text: <> $%&! <  && >> []] **"
    "]]>"
    "<!-- the end -->"
    "</TestElement>";

// This is a mid-weight interface! Just output xml code....

void test()
{
  using namespace nicai;
  std::istringstream in(xmltext);
  xml::ixmlstream xin(in);
  xml::documentroot * root = xml::documentroot::trycreate(xin, true);
  if (root)
  {
    std::cout << std::endl << "**** xml doc has been read" << std::endl;
    xml::oxmlstream xout(std::cout);
    xout << *root;
  }
  std::cout << std::endl << "**** [finished] ****" << std::endl;
}


int main(int argc, char * argv[])
{
  test();
}
