#include <iostream>
#include "nicai/xml/stream.h"
#include "nicai/xml/element.h"

// This is an heavy weight example....



///////////////////////////////////////////////////////////////////
// <can be automatically generated by xclassgen>
///////////////////////////////////////////////////////////////////
class Test2 : public nicai::xml::element
{
  public:
    nicai::xml::property<std::string> version;
    nicai::xml::property<int> count;
    nicai::xml::property<double> weight;
    nicai::xml::property<int> width;
    Test2(const std::string & name) : element(name),
      version(getAttributeRef("version")), count(getAttributeRef("count")), weight(getAttributeRef("weight")), width(getAttributeRef("width"))
      {version="1.0"; count=12; weight=0.123456789;}
    virtual Test2 * clone() const {return new Test2(*this);}
};


class Test3 : public Test2
{
  public:
    Test3(const std::string & name) : Test2(name) {}
    virtual Test3 * clone() const {return new Test3(*this);}
};


class TestElement : public nicai::xml::element
{
  public:
    explicit TestElement(const std::string & name) :element(name) {}
    virtual TestElement * clone() const {return new TestElement(*this);}
    virtual nicai::xml::element * createChildElement(const std::string & name, nicai::xml::ixmlbasestream & xin)
    {
      if (name=="Test2") return create<Test2>(name, xin, true);
      if (name=="Test3") return create<Test3>(name, xin, true);
      return element::createChildElement(name, xin);
    }
};


class Root : public nicai::xml::documentroot
{
  public:
    static Root * trycreate(nicai::xml::ixmlbasestream & xin, bool createContent = false)
    { if (xin.expectNode(nicai::xml::document())) return initChild(new Root(), xin, createContent); return 0;}
    virtual Root * clone() const {return new Root(*this);}
    virtual nicai::xml::element * createChildElement(const std::string & name, nicai::xml::ixmlbasestream & xin)
    {
      if (name=="TestElement") return create<TestElement>(name, xin, true);
      return element::createChildElement(name, xin);
    }
};

///////////////////////////////////////////////////////////////////
// </can be automatically generated by xclassgen>
///////////////////////////////////////////////////////////////////


void test()
{
  std::cout << std::endl << "**** testxmlelementinput ****" << std::endl;

  using namespace nicai;
  std::istringstream in(
    "<?xml version=\"1.0\" ?>"
    "<TestElement attr='123'>"
    "  <Test2 attr='456'>"
    "A small <b>test text</b>..."
    "  </Test2>"
    "  <!-- a comment <a></a> -->"
    "  <Test3 a='1' b='2' d='3' c='4' e='6' f='5'/>"
    "<![CDATA[abc]]>"
    "<![CDATA["
    "some dirty text: <> $%&! <  && >> []] **"
    "]]>"
    "<!-- the end -->"
    "</TestElement>"
  );
  xml::ixmlstream xin(in);

  Root * root = Root::trycreate(xin, true);

  if (root)
  {
    std::cout << std::endl << "**** xml doc has been read" << std::endl;
    xml::oxmlstream xout(std::cout);
    xout << *root;
  }
  std::cout << std::endl << "**** [finished] ****" << std::endl;
}


int main(int argc, char * argv[])
{
  test();
}
